/*
 * name:         addpiece
 *
 * description: add to the obscured list the rectangles that are currently
 *              unobscured (i.e. that only have one layer), but that will
 *              be obscured by the new layer
 *
 * synopsis:     addpiece (lp, r, bp, op, flp, p2, p3, p4)
 *              struct layer    *lp;
 *              struct rectangle    *r;
 *              struct bitmap   *bp;
 *              struct obscured *op;
 *              struct layer    *flp;
 *              int     *p2;
 *              int     *p3;
 *              int     *p4;
 *
 * globals:      none.
 *
 * calls:        addrect  (addrect.c)
 *
 * called by:    newlayer  (newlayer.c)
 */
#include "layers.h"

addpiece (lp, r, bp, op, flp, p2, p3, p4)
struct layer  *lp;
struct rectangle  *r;
struct bitmap *bp;
struct obscured *op;
struct layer  *flp;
int   *p2;                             /* unused */
int   *p3;                             /* unused */
int   *p4;                             /* unused */
{
   if (op == null)                     /* this piece is occupied by only one
                                         layer */
        addrect (r, flp);
 /*
 * otherwise it's already in obs list
 */
}
