/*
 * NAME:         A
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW HILBERT CURVES.
 *
 * SYNOPSIS:     A (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        D        (HILBERT.C)
 *              DO_PLOT   (HILBERT.C)
 *              A         (HILBERT.C)
 *              B         (HILBERT.C)
 *
 * CALLED BY:    HILBERT.C  (HILBERT.C)
 *              A           (HILBERT.C)
 *              B           (HILBERT.C)
 *              D           (HILBERT.C)
 */
A (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        D (I - 1, H, OLD, CUR);
       CUR -> X -= H;
       DO_PLOT (OLD, CUR);
        A (I - 1, H, OLD, CUR);
       CUR -> Y -= H;
       DO_PLOT (OLD, CUR);
        A (I - 1, H, OLD, CUR);
       CUR -> X += H;
       DO_PLOT (OLD, CUR);
        B (I - 1, H, OLD, CUR);
   }
}
