/*
 * NAME:         B
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW HILBERT CURVES.
 *
 * SYNOPSIS:     B (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        C        (HILBERT.C)
 *              DO_PLOT   (HILBERT.C)
 *              B         (HILBERT.C)
 *              A         (HILBERT.C)
 *
 * CALLED BY:    A          (HILBERT.C)
 *              B           (HILBERT.C)
 *              C           (HILBERT.C)
 */
B (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        C (I - 1, H, OLD, CUR);
       CUR -> Y += H;
       DO_PLOT (OLD, CUR);
        B (I - 1, H, OLD, CUR);
       CUR -> X += H;
       DO_PLOT (OLD, CUR);
        B (I - 1, H, OLD, CUR);
       CUR -> Y -= H;
       DO_PLOT (OLD, CUR);
        A (I - 1, H, OLD, CUR);
   }
}
