/*
 * NAME:         C
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW HILBERT CURVES.
 *
 * SYNOPSIS:     C (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        B        (HILBERT.C)
 *              DO_PLOT   (HILBERT.C)
 *              C         (HILBERT.C)
 *              D         (HILBERT.C)
 *
 * CALLED BY:    B          (HILBERT.C)
 *              C           (HILBERT.C)
 *              D           (HILBERT.C)
 */
C (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        B (I - 1, H, OLD, CUR);
       CUR -> X += H;
       DO_PLOT (OLD, CUR);
        C (I - 1, H, OLD, CUR);
       CUR -> Y += H;
       DO_PLOT (OLD, CUR);
        C (I - 1, H, OLD, CUR);
       CUR -> X -= H;
       DO_PLOT (OLD, CUR);
        D (I - 1, H, OLD, CUR);
   }
}
