/*
 * name:         intersection
 *
 * description: calculate the intersection of the two rectangles r and s.
 *
 * synopsis:     intersection (r, ss, t)
 *              struct rectangle    *r;
 *              struct rectangle    *ss;
 *              struct rectangle    *t;
 *
 * globals:      none.
 *
 * calls:        nothing.
 *
 * called by:    layerop  (layerop.c)
 */
#include "layers.h"

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

intersection (r, ss, t)
struct rectangle  *r;
struct rectangle  *ss;
struct rectangle  *t;
{

    t -> origin.x = max ( r -> origin.x, ss -> origin.x);
    t -> origin.y = max ( r -> origin.y, ss -> origin.y);
    t -> corner.x = min ( r -> corner.x, ss -> corner.x);
    t -> corner.y = min ( r -> corner.y, ss -> corner.y);
}
