/* src/layers.c @finen */

/*
 * file:         layers.c
 *
 * sccs-id:      @(#)layers.c  1.2  85/03/24
 *
 * description: this file contains the one routine layers which
 *              initialises the layers code.
 *
 * author:       simon kenyon.
 *
 * history:      sck  1.1  85/03/21  created.
 *              sck   1.2  85/03/24  changed the include files around.
 */

#include "layers.h"

struct layer  *toplayer;
struct layer  *bottomlayer;
struct bitmap *display;
struct rectangle   disprect = {{
       0, 0
}, {
   256, 256
}
};

/*
 * name:         layers
 *
 * description: initialise my implementation of layers
 *              as described in
 *
 *               acm transactions on graphics,
 *              april 1983 - vol. 2, no. 2.
 *
 *              and also in
 *
 *              software - practice and experience,
 *              february 1985 - vol. 15, no. 2.
 *
 * synopsis:     layers ()
 *
 * globals:      toplayer     (w)
 *              bottomlayer   (w)
 *              display       (w)
 *              disprect      (r/w)
 *
 * calls:        balloc      (balloc.c)
 *              background   (background.c)
 *
 * called by:    this is a top-level routine.
 */
layers ()
{
   struct bitmap   *balloc ();

   toplayer = null;
   bottomlayer = null;
   display = balloc (disprect);
   (void) background (display -> bitmap_rect);
}
