/*
 * name:         lbblt
 *
 * description: given a layer l, a rectangle r, a bitmap db, a bitmap sb,
 *              a function code f and an obscured list o, bitblt using
 *              the function code f, the rectangular area r from sb into db.
 *
 * synopsis:     lbblt (l, r, db, o, sb, hb, dp, f)
 *              struct layer    *l;
 *              struct rectangle    *r;
 *              struct bitmap   *db;
 *              struct obscured *o;
 *              struct bitmap   *sb;
 *              struct bitmap   *hb;
 *              struct point    *dp;
 *              int     *f;
 *
 * globals:      none.
 *
 * calls:
 *              bitblt   (bitblt.c)
 *
 * called by:    rlayerop  (rlayerop.c)
 */
#include "layers.h"

lbblt (l, r, db, o, sb, hb, dp, f)
struct layer  *l;
struct rectangle  *r;
struct bitmap *db;                     /* destination bitmap */
struct obscured *o;
struct bitmap *sb;                     /* source bitmap */
struct bitmap *hb;                     /* halftone bitmap */
struct point  *dp;
int   *f;                              /* function code */
{
   struct rectangle  pr;
   pr.origin.x = (r -> origin.x) - (dp -> x);
   pr.origin.y = (r -> origin.x) - (dp -> y);
   pr.corner.x = (r -> corner.x) - (dp -> x);
   pr.corner.y = (r -> corner.x) - (dp -> y);
   (void) bitblt (sb, &pr, db, &(r -> origin), hb, *f);
}
