/*
 * name:         lessthan
 *
 *  description: define an ordering on the rectangles a and b,
 *              so that bitblt will be called by lbitblt
 *              in the correct order.
 *
 * synopsis:     boolean lessthan (a, b)
 *              struct rectangle    *a;
 *              struct rectangle    *b;
 *
 * globals:      delta  (r)
 *
 * calls:        nothing.
 *
 * called by:    pass  (pass.c)
 */
#include "layers.h"

extern struct point delta;

boolean lessthan (a, b)
struct rectangle  *a;
struct rectangle  *b;
{
    if ((a -> origin.y < b -> corner.y) && (b -> origin.y < a -> corner.y))
       return (((a -> origin.x - b -> origin.x) * delta.x) >= 0);
   else
       return (((a -> origin.y - b -> origin.y) * delta.y) >= 0);
}
