/*
 * NAME:         MAIN
 *
 * DESCRIPTION: MAIN LINE PROGRAM TO CALL THE LAYERS CODE TEST ROUTINE.
 *
 * SYNOPSIS:     MAIN(ARGC, ARGV)
 *              INT     ARGC;
 *              CHAR **ARGV;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        ATOI     (LIBC)
 *              FREOPEN   (LIBC)
 *              FPRINTF   (LIBC)
 *              DONE      (JERQ.C)
 *              USAGE     (JERQ.C)
 *              LAYERS    (LAYERS.C)
 *              TEST      (TEST.C)
 *
 * CALLED BY:    OPERATING SYSTEM.
 */
#INCLUDE <STDIO.H>

#INCLUDE "LAYERS.H"

MAIN (ARGC, ARGV)
INT    ARGC;
CHAR **ARGV;
{
   CHAR    *CP;
   INT      PLTSIZ;
   INT      TESTNO;

    PLTSIZ = 1;
    TESTNO = 1;
    FOR (; ARGC > 1; ARGC--) {
        ARGV++;
       IF (**ARGV == '-') {
            SWITCH (*++*ARGV) {
               CASE 'O':               /* DEFINE OUTPUT FILE */
                   IF (ARGC >= 2) {
                   /*
                    * OPEN OUTPUT FILE
                    */
                       IF (FREOPEN (*++ARGV, "W", STDOUT) == NULL) {
                            FPRINTF (STDERR, "JERQ: CANNOT OPEN %S\N", *ARGV);
                           DONE (1);
                       }
                        ARGC--;
                   }
                   CONTINUE;
               CASE 'S':               /* PLOT SIZE */
                   PLTSIZ = ATOI (++*ARGV);
                   CONTINUE;
               CASE 'T':               /* TEST NO. */
                   TESTNO = ATOI (++*ARGV);
                   CONTINUE;
               DEFAULT:
                   FPRINTF (STDERR, "JERQ: UNKNOWN OPTION %S\N", *ARGV);
                   USAGE ();
                   CONTINUE;
           }
       }
   }
   TEST (TESTNO, PLTSIZ);              /* TEST THE "LAYERS" CODE */
   DONE (0);
}
