/*
 * name:         rectf
 *
 * description: perform the function specified by integer code f,
 *              in a rectangle r, in a bitmap b.
 *
 * synopsis:     rectf (b, r, f)
 *              struct bitmap   *b;
 *              struct rectangle    *r;
 *              int      f;
 *
 * globals:      none.
 *
 * calls:        bitblt   (bitblt.c)
 *
 * called by:    newlayer  (newlayer.c)
 */
#include "layers.h"

rectf (b, r, f)
struct bitmap *b;
struct rectangle  *r;
int    f;
{
   switch (f) {
       case clr:
       /*
        * clear r to zeros
        */
           (void) bitblt (null, r, b, &(r -> origin), null, all_zeros);
           break;
       case or:
       case store:
       /*
        * set r to ones
        */
           (void) bitblt (null, r, b, &(r -> origin), null, all_ones);
           break;
       case xor:
       /*
        * invert bits in r
        */
           (void) bitblt (null, r, b, &(r -> origin), null, nd);
           break;
   }
}
