/*
 * name:         rectxrect
 *
 * description: test to see if the two rectangles r and s intersect.
 *
 * synopsis:     boolean rectxrect (r, ss)
 *              struct rectangle    *r;
 *              struct rectangle    *ss;
 *
 * globals:      none.
 *
 * calls:        nothing.
 *
 * called by:    newlayer  (newlayer.c)
 *              addobs     (addobs.c)
 *              layerop    (layerop.c)
 *              rlayerop   (rlayerop.c)
 *              upfront    (upfront.c)
 */
#include "layers.h"

boolean rectxrect(r, ss)
struct rectangle  *r;
struct rectangle  *ss;
{
   return ((r -> origin.x < ss -> corner.x) &&
           (ss -> origin.x < r -> corner.x) &&
           (r -> origin.y < ss -> corner.y) &&
           (ss -> origin.y < r -> corner.y));
}
