/*
 * name:         screenswap
 *
 * description: interchange the data in the bitmap b with the contents
 *              of the rectangle r on the screen.
 *
 * synopsis:     screenswap (b, r)
 *              struct bitmap   *b;
 *              struct rectangle    *r;
 *
 * globals:      display  (r/w)
 *
 * calls:        bitblt  (bitblt.c)
 *
 * called by:    upfront  (upfront.c)
 */
#include "layers.h"

extern struct bitmap  *display;

screenswap (b, r)
struct bitmap *b;
struct rectangle  *r;
{
 /*
 * implemented, without auxialiary storage, using three
 * calls to bitblt() with function code xor
 */
   (void) bitblt (display, &r, b, &(r -> origin), null, s_xor_d);
   (void) bitblt (b, &r, display, &(r -> origin), null, s_xor_d);
   (void) bitblt (display, &r, b, &(r -> origin), null, s_xor_d);
}
