/*
 * NAME:         A
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW SIERPINSKI CURVES.
 *
 * SYNOPSIS:     A (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        A        (SIERPINSKI.C)
 *              DO_PLOT   (SIERPINSKI.C)
 *              B         (SIERPINSKI.C)
 *              D         (SIERPINSKI.C)
 *
 * CALLED BY:    SIERPINSKI  (SIERPINSKI.C)
 *              A            (SIERPINSKI.C)
 *              B            (SIERPINSKI.C)
 *              D            (SIERPINSKI.C)
 */
A (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        A (I - 1, H, CUR, OLD);
       OLD -> X += H;
       OLD -> Y -= H;
      DO_PLOT (CUR, OLD);
       B (I - 1, H, CUR, OLD);
      OLD -> X += 2 * H;
      DO_PLOT (CUR, OLD);
        D (I - 1, H, CUR, OLD);
       OLD -> X += H;
       OLD -> Y += H;
       DO_PLOT (CUR, OLD);
        A (I - 1, H, CUR, OLD);
   }
}
