/*
 * NAME:         C
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW SIERPINSKI CURVES.
 *
 * SYNOPSIS:     C (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        C        (SIERPINSKI.C)
 *              DO_PLOT   (SIERPINSKI.C)
 *              D         (SIERPINSKI.C)
 *              B         (SIERPINSKI.C)
 *
 * CALLED BY:    SIERPINSKI  (SIERPINSKI.C)
 *              B            (SIERPINSKI.C)
 *              C            (SIERPINSKI.C)
 *              D            (SIERPINSKI.C)
 */
C (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        C (I - 1, H, CUR, OLD);
       OLD -> X -= H;
       OLD -> Y += H;
       DO_PLOT (CUR, OLD);
        D (I - 1, H, CUR, OLD);
       OLD -> X -= 2 * H;
       DO_PLOT (CUR, OLD);
        B (I - 1, H, CUR, OLD);
       OLD -> X -= H;
       OLD -> Y -= H;
       DO_PLOT (CUR, OLD);
        C (I - 1, H, CUR, OLD);
   }
}
