/*
 * NAME:         D
 *
 * DESCRIPTION: RECURSIVE PROCEDURE USED TO DRAW SIERPINSKI CURVES.
 *
 * SYNOPSIS:     D (I, H, OLD, CUR)
 *              INT      I;
 *              INT      H;
 *              STRUCT POINT    *CUR;
 *              STRUCT POINT    *OLD;
 *
 * GLOBALS:      NONE.
 *
 * CALLS:        D        (SIERPINSKI.C)
 *              DO_PLOT   (SIERPINSKI.C)
 *              A         (SIERPINSKI.C)
 *              C         (SIERPINSKI.C)
 *
 * CALLED BY:    SIERPINSKI  (SIERPINSKI.C)
 *              A            (SIERPINSKI.C)
 *              C            (SIERPINSKI.C)
 *              D            (SIERPINSKI.C)
 */
D (I, H, OLD, CUR)
INT    I;
INT    H;
STRUCT POINT  *CUR;
STRUCT POINT  *OLD;
{
   IF (I > 0) {
        D (I - 1, H, CUR, OLD);
       OLD -> X += H;
       OLD -> Y += H;
       DO_PLOT (CUR, OLD);
        A (I - 1, H, CUR, OLD);
       OLD -> Y += 2 * H;
       DO_PLOT (CUR, OLD);
        C (I - 1, H, CUR, OLD);
       OLD -> X -= H;
       OLD -> Y += H;
       DO_PLOT (CUR, OLD);
        D (I - 1, H, CUR, OLD);
   }
}
