/* Copyright (c) 1994 by John Gambini
*/

#include "screen.h"
#include "compudex.h"

SCREEN main_menu[] = {
	{  3, 32,  "COMPUDEX DATABASE"	},
	{  7, 24,  "1. INITIALIZE MAILING LIST FILES" },
	{  9, 24,  "2. ENTER NAMES AND ADDRESSES"	},
	{ 11, 24,  "3. EXIT"						},
	{ 21, 27,  "Enter Selection ( 1 - 3 )"		},
	{-1,  -1,  ""								}
	};

SCREEN data_entry[] = {
	{  1, 2,  "(S)earch  (A)dd  (U)pdate  (D)elete  (P)rint  (E)xit"	},
	{  3, 2,  "Entry Number:"	},
	{  4, 2,  "Name        :"	},
	{  5, 2,  "Address     :" 	},
	{  6, 2,  "Address     :" 	},
	{  7, 2,  "City        :"	},
	{  8, 2,  "State       :"	},
	{  9, 2,  "Zip         :"	},
	{ 10, 2,  "Phone       :"	},
	{ 11, 2,  "Fax         :"	},
	{ 12, 2,  "Type        :"	},
	{-1,  -1,  ""				}
	};

void ReportError( char *msg );

void cdecl main()
{
	int wRoot, wData, wStat, ch,rc, fhdl;

	rc = Screen( &wRoot, INIT, 0x17, 0 );
	if( rc == ERROR )
		exit(1);

	WriteStrings( &wRoot, main_menu, 0x17 );
	Screen( &wRoot, OPEN_WINDOW, 0 );

	Screen( &wRoot, SET_CURSOR, 21, 53 );
	Screen( &wRoot, SET_CURSOR_TYPE, NORMAL ); 

	while(( ch = getch()) != '3' )
	{
		switch( ch )
		{
		case '1':
			InitISAM();
			break;
		case '2':
			Screen( &wData, CREATE_WINDOW, 4, 9, 62, 16, 0x17, 3 );
			Screen( &wStat, CREATE_WINDOW,18,10, 60, 1, 0x70, -1 );
			WriteStrings( &wData, data_entry, 0x17 );
			Screen( &wData, OPEN_WINDOW, 1 );
			Screen( &wStat, PUT_STRING, 0, 1, "Help = FN1", 0x70 );
			Screen( &wStat, OPEN_WINDOW, 0 );
			Screen( &wData, SET_CURSOR, 1, 55 );
			fhdl = ISMOpen( MAILLST ); 
			if( fhdl == ERROR )
				ReportError("Error while attempting to open ISAM file.");
			else
			{
				Actions( wData, wStat, fhdl );  
				ISMClose( fhdl );
			}
			Screen( &wStat, CLOSE_WINDOW );
			Screen( &wStat, DESTROY_WINDOW );
			Screen( &wData, CLOSE_WINDOW );
			Screen( &wData, DESTROY_WINDOW );
			Screen( &wRoot, SET_CURSOR, 21, 53 );
			break;
		}
	}

	Screen( &wRoot, RESTORE );

}

void ReportError( char *msg )
{
	int wError,x,y,a;
	int top = 8, left = (80-strlen(msg)+4)/2, width = strlen(msg)+4, depth = 6;

	Screen( &wError, GET_CURSOR_ABS, &y, &x, &a);

	Screen( &wError, CREATE_WINDOW, top, left, width, depth, 0x74, 0 );

	Screen( &wError, PUT_STRING, 0, (width-7)/2," Error ",  0x74 );

	Screen( &wError, PUT_STRING, 2, 2, msg , 0x70 );

	Screen( &wError, PUT_STRING, 4, 2, "Press Any Key.", 0x70 );

	Screen( &wError, SET_CURSOR, 4, 17 );
 
	Screen( &wError, OPEN_WINDOW, 1 );

	getch();

	Screen( &wError, CLOSE_WINDOW );

	Screen( &wError, DESTROY_WINDOW );

	Screen( &wError, SET_CURSOR_ABS, y, x, a );
}

