/*---------------------------------------------------------------------
 File: screen.h
 ---------------------------------------------------------------------*/
#ifndef _SCREEN
#define _SCREEN
 
#ifndef _GENERAL
#include <general.h>
#endif

#define MAXWIDTH 80
#define MAXHEIGHT 25

typedef struct _screen {
	int y;
	int x;
	char *string;
} SCREEN;

typedef struct _window
{
	int top;
	int left;
	int width;
	int depth;
	int shadow;
	char *save;
	int is_open;  /* needed for version 1.00 */
	struct _window *prev_window;
	struct _window *next_window;
	char atr;
}WINDOW,*PWINDOW;

#define	INIT				1
#define	RESTORE				2
#define	GET_MODE			3
#define	GET_CURSOR			4
#define	SET_CURSOR_TYPE		5
#define	SET_CURSOR			6
#define	SELECT_PAGE			7
#define	CLEAR_PAGE			8
#define	CURR_PAGE			9
#define	PUT_CHAR			10
#define	PUT_STRING			11
#define	OPEN_WINDOW			12
#define	CLOSE_WINDOW		13
#define	CREATE_WINDOW		14
#define	DESTROY_WINDOW		15
#define	REFRESH_WINDOW_ABS	16
#define	SET_ATRIB			17
#define	REPOSITION_WINDOW	18
#define	GET_CURSOR_ABS		19
#define    SET_CURSOR_ABS      20
#define	REFRESH_WINDOW		21
/*-- cursor attributes ---*/

#define	NORMAL		0x0708
#define	INVISIBLE	0x1700
#define	FAT			0x0408

/*-- vector interups ---*/
#define CRIT 0x24

extern int cdecl Screen( int *wHandle, int mode, ... );
extern void WriteStrings( int *wHandle, SCREEN *scr_desc, char atr );
extern int CriticalError;

#endif
