		name		driver
		title	'MS-DOS Device driver intercept routine'

;	This code describes a device driver intercept routine
; for MS-DOS version 3.1.  The intercept routine will
; receive calls from MS-DOS and pass them to routines coded
; in any of Microsoft's high level languages.

__acrtused	EQU	9876H
		PUBLIC	__acrtused	; Resolve C startup reference
		PUBLIC	_seg_end		; Highest address in segment

stack_size	EQU	1024			; Word size of HLL stack

		EXTRN	_strategy:NEAR	; HLL Strategy routine
		EXTRN	_intrupt:NEAR	; HLL Interrupt routine

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
_TEXT	ENDS

_DATA	SEGMENT WORD PUBLIC 'DATA'
_DATA	ENDS

CONST	SEGMENT WORD PUBLIC 'CONST'
CONST	ENDS

_BSS		SEGMENT WORD PUBLIC 'BSS'
_BSS		ENDS

LAST		SEGMENT WORD
LAST		ENDS

DGROUP		GROUP _TEXT, CONST, _BSS, _DATA, LAST

		ASSUME	cs:DGROUP

_TEXT	SEGMENT BYTE PUBLIC 'CODE'

		ORG		0
header		DD		-1			; Link to next device
		DW		8000H			; Device attribute word
		DW		OFFSET strategy		; Strategy entry point
		DW		OFFSET interrupt	; Interrupt entry point
		DB		'JimDunn0'		; Character device name
;		DB		1			; Number of units
;		DB		7 DUP (?)		; Reserved
		PAGE

strategy	PROC		FAR

		pushf					; Save flags
		push		ax			; Save registers
		push		bx
		push		cx
		push		dx
		push		ds
		push		es
		push		di
		push		si
		push		bp

; Setup stack for use by HLL

		mov		ax,cs
		mov		ds,ax

		ASSUME	ds:DGROUP

		mov		save_ss,ss
		mov		save_sp,sp

		mov		sp,offset stack_end
		mov		ss,ax

		ASSUME	ss:DGROUP

		push		es			; Push FAR address of
		push		bx			; request header

		call		_strategy

; Restore system stack

		mov		ss,save_ss
		mov		sp,save_sp

		pop		bp			; Restore registers
		pop		si
		pop		di
		pop		es
		pop		ds
		pop		dx
		pop		cx
		pop		bx
		pop		ax
		popf					; Restore flags

		ret

strategy	ENDP

		PAGE

interrupt	PROC		FAR

		pushf				; Save flags
		push		ax			; Save registers
		push		bx
		push		cx
		push		dx
		push		ds
		push		es
		push		di
		push		si
		push		bp

; Setup stack for use by HLL

		mov		ax,cs
		mov		ds,ax

		ASSUME	ds:DGROUP

		mov		save_ss,ss
		mov		save_sp,sp

		mov		sp,offset stack_end
		mov		ss,ax

		ASSUME	ss:DGROUP

		call		_intrupt

; Restore system stack

		mov		ss,save_ss
		mov		sp,save_sp

		pop		bp			; Restore registers
		pop		si
		pop		di
		pop		es
		pop		ds
		pop		dx
		pop		cx
		pop		bx
		pop		ax
		popf					; Restore flags

		ret

interrupt	ENDP

_TEXT	ENDS

_BSS		SEGMENT WORD PUBLIC 'BSS'
		DW		stack_size DUP (?)
stack_end	LABEL WORD
save_ss	DW		?			; Save area for DOS ss
save_sp	DW		?			; Save area for DOS sp
_BSS		ENDS

LAST		SEGMENT WORD
_seg_end	LABEL WORD
LAST		ENDS
		END
