/* devlist.c, Loewy Ron, 1990 - list Dos device list */

#include <dos.h>
#include <stdio.h>

#define CHAR_DEVICE 0x8000

union REGS regs;
struct SREGS sregs;
struct devhdr far * p;
char far * b;
char devname[] = "........\0";
short int i;

void main(void)
{

    int offset;
   
   regs.h.ah = 0x30; /* get dos version */
   intdos(&regs, &regs);
   if (regs.h.al >= 3)
         offset = 0x22;
      else
         offset = 0x11; /* where first device starts */
   regs.h.ah = 0x52; /* return dos list of lists */
   intdosx(&regs, &regs, &sregs);
   FP_OFF(b) = regs.x.bx;
   FP_SEG(b) = sregs.es; /* p points to list of lists */
   p = (struct devhdr far *) (b + offset);
   printf("\ndevList version 1.0, Loewy Ron, 1990");
   printf("\n\nnext_dev  attr name");
   do {
      for (i=0 ; i<8; i++)
        devname[i] = p->dh_name[i];
      if (p->dh_attr & CHAR_DEVICE)
         printf("\n%p %x %8s", p->dh_next, p->dh_attr, devname);
      else
         printf("\n%p %04x %8s units : %u", p->dh_next, p->dh_attr,
                  "BLOCKDEV", devname[0]);
      p = (struct devhdr far *) p->dh_next;
      } while ( FP_OFF(p) != 0xFFFF );
   printf("\n");
}
