
/* --- EMSLIB.H --- */

/* --- Status and error globals for EMS interface library --- */

extern unsigned char EMStat;
extern unsigned char EMSVer;
extern unsigned char emserr;
extern unsigned EMSPgFrm;
extern unsigned EMSPgNum;
extern unsigned EMSAvPgs;

/* --- extern function declarations for EMS interface library --- */

extern unsigned        emsavail    (void);
extern unsigned char   _emsinit    (void);
extern unsigned char   emsgetstat  (void);
extern unsigned        emsgetpgfrm (void);
extern unsigned        emspages    (void);
extern unsigned char   _emsopen    (unsigned);
extern unsigned char   _emsmap     (unsigned, unsigned, unsigned char);
extern unsigned char   _emsclose   (unsigned char);
extern unsigned char   minver      (void);
extern unsigned char   majver      (void);
extern unsigned char   emssvmap    (unsigned char);
extern unsigned char   emsrsmap    (unsigned char);
extern unsigned char   emshnum     (void);
extern unsigned        emspgsowned (unsigned char);

/* --- error code constants for EMS interface library --- */

#define NOERR    (0)       /* Everything's cool */
#define SOFTERR  (0x80)    /* internal error in EMM software */
#define HARDERR  (0x81)    /* malfunction in expanded-memory hardware */
#define EMMBUSY  (0x82)    /* EMM busy */
#define INVHAND  (0x83)    /* invalid handle */
#define FUNCNDF  (0x84)    /* function not defined */
#define NOHANDL  (0x85)    /* no more handles available */
#define ERRINMC  (0x86)    /* error in save or restore of mapping context */
#define REQPHYS  (0x87)    /* requested # of pages not in system */
#define REQAVAIL (0x88)    /* requested # of pages not available */
#define ZPGSREQ  (0x89)    /* zero pages cannot be allocated */
#define LPGNTOWN (0x8A)    /* logical page out of range for handle */
#define ILLPGNUM (0x8B)    /* illegal physical page # !(0 > pg < 3) */
#define SVAREAFL (0x8C)    /* page-mapping hardware state area full */
#define SVMAPFL  (0x8D)    /* save of mapping context failed */
#define RESMAPFL (0x8E)    /* restore of mapping context failed */
#define SBFNCPND (0x8F)    /* subfunction parameter not defined */
#define NOEMS    (0x90)    /* no EMM software */
