/****************************************************************************/
/*                                                                          */
/*                    Copyright (c) 1991 Primatech Inc.                     */
/*                                                                          */
/*                           All Rights Reserved                            */
/*                                                                          */
/****************************************************************************/



// $config$=/MTEdtWnd2.cpp
//
//  $NAME$:
//          ..Module Overview
//
//  $GLOBAL PATHS$
//          modules\all\TEdtWnd2.cpp
//          modules\c++\TEdtWnd2.cpp
//          objects\TEditWindow
//
//  $0$
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//  Purpose:    To define a sizeLimits() function for the TEditWindow class.
//              Without it, the scroll bar gets overwritten and is unusable.
//
//  Prototypes location:    $/SEE(editors.hpp)$
//
//  Other Information:
//
//  See also:       $/SEE()$
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


//$-1$
#if 0
//$1$
/**** MODIFICATIONS HISTORY ****/

Created:        November 1991 by John L. Swartzentruber


$SKIP START$
#endif

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+                                                                        +*/
/*+                       I N C L U D E   F I L E S                        +*/
/*+                                                                        +*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#define Uses_TEditWindow
#include <tv.h>



//$SKIP END$
//$2$
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+                                                                        +*/
/*+       # D E F I N E S    C L A S S E S   and    T Y P E D E F S        +*/
/*+                                                                        +*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



//$3$
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+                                                                        +*/
/*+                E X T E R N A L    D E F I N I T I O N S                +*/
/*+                                                                        +*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


//$4$
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+                                                                        +*/
/*+                  S T A T I C    D E F I N I T I O N S                  +*/
/*+                                                                        +*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



//$END$
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+                                                                        +*/
/*+          S T A T I C   F U N C T I O N   P R O T O T Y P E S           +*/
/*+                                                                        +*/
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


/* EJECT */
//****************************************************************************
//
//      Function $NAME$:
//                          TEditWindow::sizeLimits( TPoint&, TPoint& )
//                                                                            $1$
// 
//      Purpose:    To indicate what the size limits are for an edit window.
//
//      Return:     None
//
//      Other information:
//
//$0$
//****************************************************************************
void TEditWindow::sizeLimits( TPoint& min, TPoint& max )
//                                                                            $END$
{
    TWindow::sizeLimits(min, max);

    if (min.x < 20)
        min.x = 20;
}
